import { BC_TERRAIN_SETTINGS } from "../GlobalVariables/GlobalVariables";
import { ChunkStorageTypes } from "../WorldGeneration/WorldChunk/WorldGenChunk";
import { getTileAt } from "../WorldGeneration/WorldGen";
import { PointInt2D } from "./Math.utils";
import { TerrainTile } from "../WorldGeneration/WorldObjects/TerrainTile/TerrainTile";

class PathFinderNode
{
    position;
    fScore;
    neighbors;

    /**
     * 
     * @param {PointInt2D} position 
     * @param {Number} fScore 
     */
    constructor(position, fScore)
    {
        this.position = position;
        this.fScore = fScore;
    }
};

export class PathFinder
{   
    /**
     * @type Array<PathFinderNode>
     */
    _openSet = new Array();
    _closedSet = new Array();

    /**
     * 
     * @param {PointInt2D} start 
     * @param {PointInt2D} goal 
     */
    search(start, goal)
    {
        this._openSet.push(new PathFinderNode(start, 0));

        //code

        let currentNode = new PathFinderNode(new PointInt2D(), 0);
        /**
         * @type Map<String, Number>
         */
        let gScores = new Map();
        /**
         * @type Map<String, Number>
         */
        let fScores = new Map();

        let minFScoreNodeIndex = 0;
        //START LOOP WOOOOAAAW
        while (this._openSet.length > 0) {
            //find node with min f score
            //better to rewrite it to priority queue
            for (let i = 0; i < this._openSet.length; i++) {
                if(this._openSet[i] < this._openSet[minFScoreNodeIndex])
                    minFScoreNodeIndex = i;
            }
            //wow! node is found and set!!
            currentNode = this._openSet[minFScoreNodeIndex];

            if(PointInt2D.isEqual(currentNode.position, goal))
            {
                //wow!!! we have found an end of the path!!! this is so cool!!!
                return 1111; //return something weird stuff
            }

            //and now we must delete this node... what a sad situation...
            this._openSet.splice(minFScoreNodeIndex, 1);
            //but wait! we add it to closed set! nice!!! (why we are doing this??? idk... okay)
            this._closedSet.push(currentNode);

            /**
             * @type TerrainTile
             */
            let neighbors = this._getNeighbors(currentNode.position);
            return neighbors;
        }
    }

    /**
     * 
     * @param {PointInt2D} root 
     */
    _getNeighbors(root)
    {
        let neighborNorth = getTileAt(root.getX(), root.getY() - BC_TERRAIN_SETTINGS.tileSize*BC_TERRAIN_SETTINGS.scale, ChunkStorageTypes.TYPE_TERRAIN);
        return neighborNorth;
        //TODO
    }
};